/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : KBI1.C
**     Project   : PE_LL64_Quick_Start
**     Processor : MC9S08LL64C_LQFP80
**     Component : Init_KBI
**     Version   : Component 01.041, Driver 01.13, CPU db: 3.00.023
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 11/30/2009, 5:48 PM
**     Abstract  :
**          This file implements the KBI (KBI) module initialization
**          according to the Peripheral Initialization Bean settings, and defines
**          interrupt service routines prototypes.
**          The KBI module is the serial peripheral interface module,which allows 
**          full-duplex, synchronous, serial communications with peripheral devices.
**          The keyboard interrupt module (KBI) provides a few independently maskable 
**          external interrupts. When a port pin is enabled for keyboard interrupt 
**          function, an internal pullup/pulldown device is also enabled on the pin.

**     Settings  :
**          Bean name                                      : KBI1
**          Device                                         : KBI
**          Settings 
**            Triggering sensitivity                       : edge
**          Pins 
**            Pin0                                         : Disabled
**            Pin1                                         : Disabled
**            Pin2                                         : Disabled
**            Pin3                                         : Disabled
**            Pin4                                         : Enabled
**              Pin                                        : PTA4_KBIP4_ADP8_LCD43
**              Pin signal                                 : 
**            Pin5                                         : Disabled
**            Pin6                                         : Disabled
**            Pin7                                         : Enabled
**              Pin                                        : PTA7_KBIP7_ADP11_ACMPMINUS
**              Pin signal                                 : 
**          Interrupts 
**            Keyboard request 
**              Interrupt                                  : Vkeyboard
**              Keyboard request interrupt                 : Enabled
**              ISR name                                   : KBI_ISR
**          Initialization 
**            Call Init method                             : yes
**     Contents  :
**         Init - void KBI1_Init(void);
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE KBI1. */

#include "KBI1.h"

/*
** ###################################################################
**
**  The interrupt service routine(s) must be implemented
**  by user in one of the following user modules.
**
**  If the "Generate ISR" option is enabled, Processor Expert generates
**  ISR templates in the CPU event module.
**
**  User modules:
**      PE_LL64_Quick_Start.c
**      Events.c
**
** ###################################################################
#pragma CODE_SEG __NEAR_SEG NON_BANKED
ISR(KBI_ISR)
{
  // NOTE: The routine should include the following actions to obtain
  //       correct functionality of the hardware.
  //
  //  Keyboard Interrupt Flag is cleared by writing a 1 to the
  //  KBACK control bit.
  // Example:   KBISC_KBACK = 0x01;
}
#pragma CODE_SEG DEFAULT
*/

/*
** ===================================================================
**     Method      :  KBI1_Init (component Init_KBI)
**
**     Description :
**         This method initializes registers of the KBI module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in user code to initialize the module.
**         By default, the method is called by PE automatically; see
**         "Call Init method" property of the bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void KBI1_Init(void)
{
  /* KBISC: KBIE=0 */
  clrReg8Bits(KBISC, 0x02);             
  /* KBIES: KBEDG7=0,KBEDG6=0,KBEDG5=0,KBEDG4=0,KBEDG3=0,KBEDG2=0,KBEDG1=0,KBEDG0=0 */
  setReg8(KBIES, 0x00);                 
  /* KBISC: KBIMOD=0 */
  clrReg8Bits(KBISC, 0x01);             
  /* KBIPE: KBIPE7=1,KBIPE6=0,KBIPE5=0,KBIPE4=1,KBIPE3=0,KBIPE2=0,KBIPE1=0,KBIPE0=0 */
  setReg8(KBIPE, 0x90);                 
  /* KBISC: KBACK=1 */
  setReg8Bits(KBISC, 0x04);             
  /* KBISC: KBIE=1 */
  setReg8Bits(KBISC, 0x02);             
}

/* END KBI1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.07 [04.34]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
